      subroutine sffmd(g,u1,u2,u3,mat)
c----------------------------------------------------------------------c
c Returns a matrix element
c
c                  mat=u1*u2*(g(1)*P(+) + g(2)*P(-))*u3
c
c Input: u1 - scalar,
c        u2,u3 - spinors
c        g - a fermion-fermion-scalar boson coupling,
c
c The gamma matrices are taken in the Weyl representation as in the 
c paper by K. Kolodziej, M. Zralek, Phys. Rev. D43 (1991) 3619
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 20 May, 2007;      modified on 23 May, 2007 (optimized)
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0)
      complex(dp) :: g(2),u1(1),u2(4),u3(4),mat

      mat=u1(1)*(g(2)*(u2(1)*u3(1)+u2(2)*u3(2))
     &          +g(1)*(u2(3)*u3(3)+u2(4)*u3(4)))
      
      end subroutine sffmd
