      subroutine backwrite(i,j,ncls,plord,id,sgn)
c----------------------------------------------------------------------c
c Does necessary writing
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 17 March, 2006; modified on 28 March, 2006; 15 May, 2006,
c                             23 October, 2007 (Wrong assignment 
c                             corrected for plord)
c 22-23 January 2014:
c Modifications for imcs=1 introduced
c----------------------------------------------------------------------c

      use mytypes
      use extpart
      use intpart

      implicit none

      integer :: i,j,ncls,id,plord(next),sgn,ii,jj,!blad,
     &           plij,plii,plio,plig,plif,plict,plin,plie,
     &           pljj,plji,pljo,pljg,pljf,pljct,pljn,plje,iplo

      integer, dimension(mxepl) :: pliix,pljix

      character(160) :: cl
      character(80) :: ind

      open(16,file='partcls.tmp',access='direct',form='formatted',
     &                                                     recl=80)
      read(16,1612,rec=i) plij,plii,plio,plig,plif,plict,plin,plie
      read(16,1612,rec=j) pljj,plji,pljo,pljg,pljf,pljct,pljn,plje

 1612 format(i8,5(i3),i24,i3)

      read(20,1620,rec=i) pliix(1:plie)
      read(20,1620,rec=j) pljix(1:plje)
 1620 format(26(i3))

      plord(1:plie)=pliix(1:plie)
      plord(plie+1:next)=pljix(1:plje)

      sgn=1

      do ii=1,next-1
       do jj=ii+1,next
        if (plord(ii) > plord(jj)) then 
         if (f(plord(ii))%j < 21 .and. f(plord(jj))%j < 21) then 
          sgn=-sgn
         end if
        end if
       end do
      end do

      write(ind,'(i16)') id

      if (size(pl(i)%ip) > 0) then
       do ii=1,size(pl(i)%ip)
        if (pl(pl(i)%ip(ii))%wr == 0) then
         read(18,'(a)',rec=pl(i)%ip(ii)) cl
         write(14,'(a)') trim(cl)
         ncls=ncls+1
         pl(pl(i)%ip(ii))%wr=1
        end if
       end do
      end if

      if (size(pl(j)%ip) > 0) then
       do ii=1,size(pl(j)%ip)
        if (pl(pl(j)%ip(ii))%wr == 0) then
         read(18,'(a)',rec=pl(j)%ip(ii)) cl
         write(14,'(a)') trim(cl)
         ncls=ncls+1
         pl(pl(j)%ip(ii))%wr=1
        end if
       end do
      end if

c Change order of particles to economize the number of internal particles

      iplo=0

      if (i > j) then

       if (pl(j)%wr == 0) then
        read(18,'(a)',rec=j) cl
        write(14,'(a)') trim(cl)
        pl(j)%wr=1
        ncls=ncls+1
       end if

       call mdcalls(i,j)

       read(16,1612,rec=pl(i)%k(2)) plij,plii,plio,plig,plif,plict,
     &                              plin,plie
       pliix=0
       read(20,1620,rec=pl(i)%k(2)) pliix(1:plie)
       plord(iplo+1:iplo+plie)=pliix(1:plie)
       iplo=iplo+plie

       read(16,1612,rec=pl(i)%k(3)) plij,plii,plio,plig,plif,plict,
     &                              plin,plie
       pliix=0
       read(20,1620,rec=pl(i)%k(3)) pliix(1:plie)
       plord(iplo+1:iplo+plie)=pliix(1:plie)
       iplo=iplo+plie

       if (pl(i)%k(4) > 0) then
        read(16,1612,rec=pl(i)%k(4)) plij,plii,plio,plig,plif,plict,
     &                               plin,plie
        pliix=0
        read(20,1620,rec=pl(i)%k(4)) pliix(1:plie)
        plord(iplo+1:iplo+plie)=pliix(1:plie)
        iplo=iplo+plie
       end if

       plord(iplo+1:next)=pljix(1:plje)

      else

       if (pl(i)%wr == 0) then
        read(18,'(a)',rec=i) cl
        write(14,'(a)') trim(cl)
        pl(i)%wr=1
        ncls=ncls+1
       end if

       call mdcalls(j,i)

       read(16,1612,rec=pl(j)%k(2)) pljj,plji,pljo,pljg,pljf,pljct,
     &                              pljn,plje
       pljix=0
       read(20,1620,rec=pl(j)%k(2)) pljix(1:plje)

       plord(iplo+1:iplo+plje)=pljix(1:plje)
       iplo=iplo+plje

       read(16,1612,rec=pl(j)%k(3)) pljj,plji,pljo,pljg,pljf,pljct,
     &                              pljn,plje
       pljix=0
       read(20,1620,rec=pl(j)%k(3)) pljix(1:plje)
       plord(iplo+1:iplo+plje)=pljix(1:plje)
       iplo=iplo+plje

       if (pl(j)%k(4) > 0) then
        read(16,1612,rec=pl(j)%k(4)) pljj,plji,pljo,pljg,pljf,pljct,
     &                               pljn,plje
        pljix=0
        read(20,1620,rec=pl(j)%k(4)) pljix(1:plje)
        plord(iplo+1:iplo+plje)=pljix(1:plje)
        iplo=iplo+plje
       end if

       plord(iplo+1:next)=pliix(1:plie)

      end if

      close(16)
c      close(18)
c      close(20)

      contains

       subroutine mdcalls(ix,jx)
        integer :: ix,jx
        character(80) :: clx,ind,ind1
        character(160) :: beg
        character(240) :: all

        open(22,file='mdclsb.txt',
     &          access='direct',form='formatted',recl=160)
        read(22,'(a)',rec=ix) beg
        close(22)

        write(ind,'(i16)') jx
        write(ind1,'(i16)') id

        if (imcs == 1) then
         clx='u'//trim(adjustl(ind))//',m'//trim(adjustl(ind1))//')'
        else
         clx='u'//trim(adjustl(ind))//'(:,h'//trim(adjustl(ind))//
     &      '(h)),m'//trim(adjustl(ind1))//')'
        end if
        all=trim(beg)//trim(clx)
        write(12,'(a)') trim(all)
       end subroutine mdcalls

      end subroutine backwrite
