c=============================================================================c
c Matrix element of the process:
c
c                      e+ e-  ->  b mu+ vm b~ mu- vm~
c
c generated with carlomat, version 4.4 of 1 June, 2023
c with the MC summing over polarizations
c
c                            Karol Kolodziej
c                         University of Silesia
c                            Katowice, Poland
c                      e-mail: karol.kolodziej@us.edu.pl
c=============================================================================c
 
      subroutine matrixel(phi,mat2)
 
      use inprms
      use fourmom
      use couplsmkk
      use hmodkk
      use pmodkk
      use umodkk
 
      implicit none
 
      integer, parameter :: next= 8, nmcs= 6
      real(dp) :: phi(nmcs),mat2,comif
      integer :: first=1,hl
 
      integer, parameter :: rdgs=1
      integer, parameter :: nhip=4, nidp=1, ncip=1
      real(8) :: mpol2
 
      save first,comif
 
      p1=p(:,1)
      p2=p(:,2)
      p3=p(:,3)
      p4=p(:,4)
      p5=p(:,5)
      p6=p(:,6)
      p7=p(:,7)
      p8=p(:,8)
 
      call spinorkk(p1,me,-1,-1,1,phi(1),u1,1)
      call spinorkk(p2,me,1,-1,1,phi(2),u2,1)
      call spinorkk(p3,mb0,1,1,1,phi(3),u3,1)
      call spinorkk(p4,mmu,-1,1,1,phi(4),u4,1)
      call spinorkk(p5,zero,1,1,0,0.d0,u5,1)
      call spinorkk(p6,mb0,-1,1,1,phi(5),u6,1)
      call spinorkk(p7,mmu,1,1,1,phi(6),u7,1)
      call spinorkk(p8,zero,-1,1,0,0.d0,u8,1)
 
      call mtel1
 
      if (first == 1) then
       comif=1.d0/(nhip*nidp*ncip)
       first=0
      end if
  
      mat2=0.d0
  
      do hl=1,nhel
       mat2=mat2+mpol2(hl)
      end do
  
      mat2=comif*mat2
  
      end subroutine matrixel
